// Infinite War

#include <math.h>
#include <xc.h>
#include <allegro.h>

#define unit_dist(X,Y) dist(unit[X].x, unit[X].y, unit[X].w, unit[X].h, unit[Y].x, unit[Y].y, unit[Y].w, unit[Y].h)
#define msgbox(X) alert(X, NULL, NULL, "OK", NULL, KEY_ENTER, 0); show_mouse(mbuff)

#define MODE_PLAY 1
#define MODE_EDIT 0

#define MAX_NAME 255
#define MAX_ANIM 30
#define MAX_UNIT 100
#define MAX_FRAMES 10
#define MAX_PICS 1024
#define MAX_BUTTONS 9
#define BCOLS 3
#define BSIZE 40
#define BBUFF (BSIZE+5)
#define MAX_MODS 255
#define MEMSZ 255
#define MAX_CUSTOM 255
#define MAX_UPGRADES 255
#define MAX_TIMERS 255
#define MAX_SELECTED 255
#define MAX_SPRITES 255
#define MAX_SOUNDS 255
#define MAX_MIDIS 255
#define MAX_MENU 20

#define MAX_X 255
#define MAX_Y 255
#define TILE_W 32
#define TILE_H 32
#define BS 255

#define EMOD_X 10
#define EMOD_Y 20
#define EMOD_W 190
#define EMOD_H 300
#define EMOD_ROWS ((EMOD_W - EMOD_X) / 10)

#define DIR_T 0
#define DIR_TR 1
#define DIR_R 2
#define DIR_BR 3
#define DIR_B 4
#define DIR_BL 5
#define DIR_L 6
#define DIR_TL 7

#define LAYER_WATER 1
#define LAYER_DEAD 2
#define LAYER_LAND 3
#define LAYER_AIR 4
#define LAYER_MAX 5

#define EVENT_INIT 1
#define EVENT_UPGRADE 2
#define EVENT_SELECT 3
#define EVENT_STAND 4
#define EVENT_MOVE 5
#define EVENT_RCLICK 6
#define EVENT_DAMAGED 7
#define EVENT_DEATH 8

#define SEL_LOC 1
#define SEL_UNIT 2

#define CREATURE	1
#define BUILDING	2
#define TERRAIN		4
#define OBJECT		8
#define COMPLETED	16

typedef struct animt {
	int n_frames, speed, loop, w, h;
	BITMAP *frame[MAX_FRAMES];
	} animt;

typedef struct unitt {
	xc *mod;
	char name[MAX_NAME];
	unsigned int flags, layer;
	int x, y, w, h, tx, ty, tn, tr, transx, transy, owner, e, lx, ly, lx2, ly2, r;
	int hp, shp, mana, smana, dmg_min, dmg_max, dmg_bonus, armor, armor_bonus;
	int speed, speed_bonus, aspeed, aspeed_bonus, asp, range, range_bonus, sight, sight_bonus;
	int shp_bonus, smana_bonus, bspeed, bspeed_bonus, taske;
	int64 custom[MAX_CUSTOM];
	BITMAP *pic;
	animt anim[MAX_ANIM];
	int canim, panim, anim_size, anim_speed, anim_tick, loop, aw, ah, ae;
	} unitt;

typedef struct buttont {
	BITMAP *pic;
	int event;
	} buttont;

typedef struct upgradet {
	xc *mod;
	int e;
	} upgradet;

typedef struct timert {
	xc *mod;
	int e, speed, loop, u, tx, ty, tick;
	int64 custom[MAX_CUSTOM];
	} timert;

typedef struct spritet {
	int u, tx, ty, canim, panim, size, speed, tick, loop, w, h, e, layer, x, y, r;
	int64 custom[MAX_CUSTOM];
	} spritet;

typedef struct menut {
	char txt[BS];
	int x, y, w, h, e;
	} menut;

buttont button[MAX_BUTTONS];
int n_buttons = 0, c_button = -1;

int player, selmode = 0, sele = 0;
unitt unit[MAX_UNIT];
int n_unit = 0;
int tile[MAX_X][MAX_Y], board_w = 30, board_h = 30, win_x = 0, win_y = 0, m_win_x, m_win_y;
int vpx = 200, vpy = 0, vpw = 440, vph = 480, vptw = 16, vpth = 15, selected[MAX_SELECTED];
int n_selected = 0;
unsigned char soundf = 1;
BITMAP *pics[MAX_PICS];
char picnames[MAX_PICS][BS];
int n_pics = 0;
char str_out[BS], basepath[80];
int lastx, lasty;

xc *mods[MAX_MODS];
char modnames[MAX_MODS][BS];
int n_mods = 0;

SAMPLE *sounds[MAX_SOUNDS];
char soundnames[MAX_SOUNDS][BS];
int n_sounds = 0;

MIDI *midis[MAX_MIDIS];
char midinames[MAX_MIDIS][BS];
int n_midis;

upgradet upgrades[MAX_UPGRADES];
int n_upgrades = 0;

timert timers[MAX_TIMERS];
int n_timers = 0, ctimer = -1;

spritet sprites[MAX_SPRITES];
int n_sprites = 0, csprite = -1;

menut menu[MAX_MENU];
int n_menu = 0, cmenu = -1;

char emods[MAX_MODS][BS];
int n_emods = 0, esamp[MAX_MODS];

char map_path[80] = "";
int mode, cmod = -1, cmods = 0;
int mx = 0, my = 0, mx2 = 0, my2 = 0, badx, bady;
int _red, _blue, _green, _white, _yellow, _black;

BITMAP *buffer, *sideframe, *map, *mbuff, *sidebar, *mmenu;

void init_bmp(BITMAP *bmp) {
set_clip(bmp, 0, 0, bmp->w, bmp->h);
}

BITMAP *get_pic(char *path) {

int j;

strlwr(path);
for (j = 0; j < n_pics; ++j)
	if (!strcmp(path, picnames[j]))
		return pics[j];

if (pics[n_pics] = load_bitmap(path, NULL)) {
	strcpy(picnames[n_pics], path);
	return pics[n_pics++];
	}
return NULL;

}

xc *get_mod(char *path) {

int j;

strlwr(path);
for (j = 0; j < n_mods; ++j)
	if (!strcmp(path, modnames[j]))
		return mods[j];

if (mods[n_mods] = load_xc(path)) {
	strcpy(modnames[n_mods], path);
	return mods[n_mods++];
	}
return NULL;

}

SAMPLE *get_sound(char *path) {

int j;

strlwr(path);
for (j = 0; j < n_sounds; ++j)
	if (!strcmp(path, soundnames[j]))
		return sounds[j];

if (sounds[n_sounds] = load_sample(path)) {
	strcpy(soundnames[n_sounds], path);
	return sounds[n_sounds++];
	}
return NULL;

}

MIDI *get_midi(char *path) {

int j;

strlwr(path);
for (j = 0; j < n_midis; ++j)
	if (!strcmp(path, midinames[j]))
		return midis[j];

if (midis[n_midis] = load_midi(path)) {
	strcpy(midinames[n_midis], path);
	return midis[n_midis++];
	}
return NULL;

}

void write_int(FILE *fl, int *i) {

char *ch = (char *)i, j;

for (j = 0; j < sizeof(int); ++j)
	fputc((int)(*ch++), fl);

}

void read_int(FILE *fl, int *i) {

char *ch = (char *)i, j;

for (j = 0; j < sizeof(int); ++j)
	*ch++ = fgetc(fl);

}

void normalize(char *str) {

strlwr(str);
for (; *str; ++str)
	if (*str == '\\')
		*str = '/';

}

void remove_bp(char *str) {

char buf[BS];

if (!strncmp(str, basepath, strlen(basepath))) {
	strcpy(buf, &str[strlen(basepath)]);
	strcpy(str, buf);
	}

}

void set_anim(unitt *u, int num) {

if (u->canim == num) return;
if (!(u->anim[num].n_frames)) return;
u->canim = num;
u->panim = 0;
u->loop = u->anim[num].loop;
u->anim_speed = u->anim[num].speed;
u->anim_size = u->anim[num].n_frames;
u->anim_tick = 0;
u->aw = u->anim[num].w;
u->ah = u->anim[num].h;

}

int load_map() {

int j, k, i, max;
char buf[BS];
FILE *fl;

strcpy(buf, map_path);
if (file_select("Load map", buf, "MAP")) {
	if (fl = fopen(buf, "rb")) {
		read_int(fl, &board_w);
		read_int(fl, &board_h);
		read_int(fl, &n_emods);
		for (j = 1; j < n_emods; ++j) {
			fgets(emods[j], BS, fl);
			emods[j][strlen(emods[j])-1] = '\0';
			}
		for (j = 0; j < board_w; ++j)
			for (k = 0; k < board_h; ++k)
				read_int(fl, &(tile[j][k]));
		read_int(fl, &max);
		n_unit = 1;
		for (j = 1; j < max; ++j) {
			read_int(fl, &k);
			if ((i = add_unit(emods[k])) == -1) {
				sprintf(buf, "Error adding unit with \"%s\"", mods[k]);
				msgbox(buf);
				for (k = 0; k < sizeof(int) * 3; ++k)
					fgetc(fl);
				}
			else {
				read_int(fl, &unit[i].x);
				read_int(fl, &unit[i].y);
				read_int(fl, &unit[i].owner);
				unit[i].flags |= COMPLETED;
				}
			}
		fclose(fl);
		strcpy(map_path, buf);
		text_mode(-1);
		show_mouse(mbuff);
		return 1;
		}
	else
		msgbox("Error writing file");
	}
text_mode(-1);
show_mouse(mbuff);
return 0;

}

void do_event(int u, int e) {

char buf[BS];

run_xc_mono(unit[u].mod, MEMSZ, 2, (int64)u, (int64)e);
if (errno) {
	sprintf(buf, "Module caused exception %d", errno);
	msgbox(buf);
	}

}

void do_event_all(int e) {

int j;
char buf[BS];

for(j = 0; j < n_unit; ++j) {
	run_xc_mono(unit[j].mod, MEMSZ, 2, (int64)j, (int64)e);
	if (errno) {
		sprintf(buf, "Module caused exception %d", errno);
		msgbox(buf);
		}
	}

}

void do_event2(int u, int e, int t) {

char buf[BS];

run_xc_mono(unit[u].mod, MEMSZ, 3, (int64)t, (int64)u, (int64)e);
if (errno) {
	sprintf(buf, "Module caused exception %d", errno);
	msgbox(buf);
	}

}

void do_event3(int u, int e, int x, int y) {

char buf[BS];

run_xc_mono(unit[u].mod, MEMSZ, 4, (int64)y, (int64)x, (int64)u, (int64)e);
if (errno) {
	sprintf(buf, "Module caused exception %d", errno);
	msgbox(buf);
	}

}

void do_event_selected(int e) {

int j;
char buf[BS];

for (j = 0; j < n_selected; ++j) {
	run_xc_mono(unit[selected[j]].mod, MEMSZ, 2, (int64)selected[j], (int64)e);
	if (errno) {
		sprintf(buf, "Module caused exception %d", errno);
		msgbox(buf);
		}
	}

}

void do_event2_selected(int e, int t) {

int j;
char buf[BS];

for (j = 0; j < n_selected; ++j) {
	run_xc_mono(unit[selected[j]].mod, MEMSZ, 3, (int64)t, (int64)selected[j], (int64)e);
	if (errno) {
		sprintf(buf, "Module caused exception %d", errno);
		msgbox(buf);
		}
	}

}

void do_event3_selected(int e, int x, int y) {

int j;
char buf[BS];

for (j = 0; j < n_selected; ++j) {
	run_xc_mono(unit[selected[j]].mod, MEMSZ, 4, (int64)y, (int64)x, (int64)selected[j], (int64)e);
	if (errno) {
		sprintf(buf, "Module caused exception %d", errno);
		msgbox(buf);
		}
	}

}

void animate_sprite(int n) {

if (sprites[n].e) {
	run_xc_mono(unit[sprites[n].u].mod, MEMSZ, 4, (int64)sprites[n].ty, (int64)sprites[n].tx, (int64)sprites[n].u, (int64)sprites[n].e);
	}

if (!sprites[n].loop) return;
if (++sprites[n].tick < sprites[n].speed) return;
sprites[n].tick = 0;

if (++sprites[n].panim >= sprites[n].size) {
	if (sprites[n].loop != -1) --sprites[n].loop;
	if (sprites[n].loop)
		sprites[n].panim = 0;
	else
		--sprites[n].panim;
	}

}

void animate(int n) {

char buf[BS];

if (!unit[n].loop) return;
if (++unit[n].anim_tick < unit[n].anim_speed) return;
unit[n].anim_tick = 0;

if (++unit[n].panim >= unit[n].anim_size) {
	if (unit[n].loop != -1) --unit[n].loop;
	if (unit[n].loop)
		unit[n].panim = 0;
	else {
		--unit[n].panim;
		if (unit[n].ae) {
			do_event(n, unit[n].ae);
			unit[n].ae = 0;
			}
		}
	}

}

int dist(int x1, int y1, int w1, int h1, int x2, int y2, int w2, int h2) {

int ux1 = x1, uw1 = x1 + w1 - 1;
int uy1 = y1, uh1 = y1 + h1 - 1;
int ux2 = x2, uw2 = x2 + w2 - 1;
int uy2 = y2, uh2 = y2 + h2 - 1;
int w = w1 + w2, h = h1 + h2;
int xc, yc;

if (uw1 < ux2)
	xc = ux2 - uw1;
else if (ux1 > uw2)
	xc = ux1 - uw2;
else
	xc = 0;

if (uh1 < uy2)
	yc = uy2 - uh1;
else if (uy1 > uh2)
	yc = uy1 - uh2;
else
	yc = 0;

return sqrt(xc*xc + yc*yc);

}

int check_loc(int n, int x, int y) {

int j, ux = x, uy = y, uw = x + unit[n].w - 1, uh = y + unit[n].h - 1;

if (ux < 0 || uw >= board_w || uy < 0 || uh >= board_h)
	return 0;

for (j = 0; j < n_unit; ++j)
	if (j != n && unit[j].hp && unit[j].layer == unit[n].layer && unit[j].x != -1 && !dist(ux, uy, unit[n].w, unit[n].h, unit[j].x, unit[j].y, unit[j].w, unit[j].h))
		return 0;

return 1;

}

int move_unit(int n, int x, int y, int tx, int ty) {

int ux = unit[n].x + x, uy = unit[n].y + y, uw = unit[n].x + x + unit[n].w - 1, uh = unit[n].y + y + unit[n].h - 1;

if ((!x && !y) || (x == badx && y == bady))
	return 0;

if (!check_loc(n, ux, uy))
	return 0;

/*{
	char buf[BS];
	sprintf(buf, "(%d,%d)", x, y);
	msgbox(buf);
}*/

lastx = x;
lasty = y;

do_event3(n, EVENT_MOVE, x, y);

if (x < 0) {
	if ((unit[n].transx -= unit[n].speed) <= -TILE_W) {
		if (ux == tx)
			unit[n].transx = 0;
		else
			unit[n].transx %= -TILE_W;
		unit[n].x = ux;
		}
	}
else if (x) {
	if ((unit[n].transx += unit[n].speed) >= TILE_W) {
		if (ux == tx)
			unit[n].transx = 0;
		else
			unit[n].transx %= TILE_W;
		unit[n].x = ux;
		}
	}
else
	unit[n].transx = 0;

if (y < 0) {
	if ((unit[n].transy -= unit[n].speed) <= -TILE_H) {
		if (uy == ty)
			unit[n].transy = 0;
		else
			unit[n].transy %= -TILE_H;
		unit[n].y = uy;
		}
	}
else if (y) {
	if ((unit[n].transy += unit[n].speed) >= TILE_H) {
		if (uy == ty)
			unit[n].transy = 0;
		else
			unit[n].transy %= TILE_H;
		unit[n].y = uy;
		}
	}
else
	unit[n].transy = 0;

return 1;

}

void _remove_timer(int n) {

for (--n_timers; n < n_timers; ++n)
	memcpy(&timers[n], &timers[n+1], sizeof(timert));

}

void remove_sprite(int n) {

for (--n_sprites; n < n_sprites; ++n)
	memcpy(&sprites[n], &sprites[n+1], sizeof(spritet));

}

void check_death(int n) {

int j;

if (unit[n].hp <= 0) {
	unit[n].hp = 0;
	unit[n].layer = LAYER_DEAD;
	do_event(n, EVENT_DEATH);
	if (selected[0] == n) {
		selected[0] = 0;
		n_buttons = 0;
		}
	for (j = 0; j < n_timers; ++j) {
		if (timers[j].u == n /*|| timers[j].t == n*/) {
			_remove_timer(j);
			--j;
			continue;
			}
		}
	}
else if (unit[n].hp > unit[n].shp + unit[n].shp_bonus)
	unit[n].hp = unit[n].shp + unit[n].shp_bonus;

}

void attack_unit(int n, int t) {

int dmg;

if ((dmg = unit[n].dmg_min + rand() % (unit[n].dmg_max - unit[n].dmg_min + 1) + 1 + unit[n].dmg_bonus) > unit[t].armor + unit[t].armor_bonus) {
	unit[t].hp -= dmg - unit[t].armor - unit[t].armor_bonus;
	do_event3(t, EVENT_DAMAGED, n, dmg - unit[t].armor - unit[t].armor_bonus);
	check_death(t);
	}

}

void think_all() {

int j, dx, dy, tx, ty, d, ox, oy;
char buf[BS], f;

for (j = 0; j < n_unit; ++j) {
	animate(j);
	if (unit[j].hp && unit[j].x == unit[j].tx && unit[j].y == unit[j].ty) {
		unit[j].tx = -1;
		do_event(j, EVENT_STAND);
		}
	if (unit[j].hp && (unit[j].tx != -1 || unit[j].tn != -1)) {
		d = 99;
		if (unit[j].tn != -1) {
			if (unit[unit[j].tn].hp) {
				tx = unit[unit[j].tn].x;
				ty = unit[unit[j].tn].y;
				if (unit_dist(j, unit[j].tn) > unit[j].tr) {
					if (unit[j].x < tx)
						dx = 1;
					else if (unit[j].x > tx)
						dx = -1;
					else
						dx = 0;

					if (unit[j].y < ty)
						dy = 1;
					else if (unit[j].y > ty)
						dy = -1;
					else
						dy = 0;
					}
				else {
					unit[j].transx = 0;
					unit[j].transy = 0;
					if (unit[j].e)
						do_event2(j, unit[j].e, unit[j].tn);
					dx = 0;
					dy = 0;
					}
				}
			else {
				unit[j].tn = -1;
				unit[j].transx = 0;
				unit[j].transy = 0;
				dx = 0;
				dy = 0;
				do_event(j, EVENT_STAND);
				}
			}
		else {
			if ((d = dist(unit[j].x, unit[j].y, unit[j].w, unit[j].h, unit[j].tx, unit[j].ty, 1, 1)) > unit[j].tr) {
				tx = unit[j].tx;
				ty = unit[j].ty;

				if (unit[j].x < tx)
					dx = 1;
				else if (unit[j].x > tx)
					dx = -1;
				else
					dx = 0;

				if (unit[j].y < ty)
					dy = 1;
				else if (unit[j].y > ty)
					dy = -1;
				else
					dy = 0;
				}
			else {
				unit[j].tx = -1;
				unit[j].ty = -1;
				unit[j].transx = 0;
				unit[j].transy = 0;
				dx = 0;
				dy = 0;
				do_event(j, EVENT_STAND);
				}
			}

		ox = unit[j].x;
		oy = unit[j].y;
		badx = unit[j].lx2;
		bady = unit[j].ly2;

		//sprintf(buf, "(%d,%d)", badx, bady);
		//msgbox(buf);

		if (!dx && !dy);
		else if (move_unit(j, dx, dy, tx, ty));
		else if (d <= 1) {
			unit[j].transx = 0;
			unit[j].transy = 0;
			}
/*		else if (!dy) {
			if (move_unit(j, dx, unit[j].ly, tx, ty));
			else if (move_unit(j, dx, unit[j].ly2, tx, ty));
			else if (move_unit(j, dx, -1, tx, ty));
			else if (move_unit(j, dx, 0, tx, ty));
			else if (move_unit(j, dx, 1, tx, ty));
			else if (move_unit(j, dx, unit[j].ly, 0, ty));
			else if (move_unit(j, dx, unit[j].ly2, 0, ty));
			else if (move_unit(j, dx, -1, 0, ty));
			else if (move_unit(j, dx, 0, 0, ty));
			else if (move_unit(j, dx, 1, 0, ty));
			}
		else if (!dx) {
			if (move_unit(j, unit[j].lx, dy, tx, ty));
			else if (move_unit(j, unit[j].lx2, dy, tx, ty));
			else if (move_unit(j, -1, dy, tx, ty));
			else if (move_unit(j, 1, dy, tx, ty));
			else if (move_unit(j, unit[j].lx, 0, tx, ty));
			else if (move_unit(j, unit[j].lx2, 0, tx, ty));
			else if (move_unit(j, -1, 0, tx, ty));
			else if (move_unit(j, 1, 0, tx, ty));
			}*/
		else {
			if (move_unit(j, dx, unit[j].ly, tx, ty));
			else if (move_unit(j, unit[j].lx, dy, tx, ty));
			else if (move_unit(j, unit[j].lx, unit[j].ly, tx, ty));

			else if (move_unit(j, dx ? 0 : -1, dy ? dy : -1, tx, ty));
			else if (move_unit(j, dx ? 0 : 1, dy ? dy : 1, tx, ty));
			else if (move_unit(j, dx ? dx : -1, dy ? 0 : -1, tx, ty));
			else if (move_unit(j, dx ? dx : 1, dy ? 0 : 1, tx, ty));

			else if (move_unit(j, unit[j].lx, 0, tx, ty));
			else if (move_unit(j, 0, unit[j].ly, tx, ty));

			else if (move_unit(j, dx, unit[j].ly2, tx, ty));
			else if (move_unit(j, unit[j].lx2, dy, tx, ty));
			else if (move_unit(j, unit[j].lx2, unit[j].ly2, tx, ty));
			else if (move_unit(j, unit[j].lx2, 0, tx, ty));
			else if (move_unit(j, 0, unit[j].ly2, tx, ty));

			else if (move_unit(j, dx, -1, tx, ty));
			else if (move_unit(j, dx, 0, tx, ty));
			else if (move_unit(j, dx, 1, tx, ty));
			else if (move_unit(j, -1, dy, tx, ty));
			else if (move_unit(j, 0, dy, tx, ty));
			else if (move_unit(j, 1, dy, tx, ty));
			}

//		sprintf(buf, "[%d,%d]", unit[j].lx, unit[j].ly);
//		msgbox(buf);
		if (unit[j].lx2 != unit[j].lx && unit[j].ly2 != unit[j].ly) {
			unit[j].lx2 = unit[j].lx;
			unit[j].ly2 = unit[j].ly;
			}
		unit[j].lx = lastx;
		unit[j].ly = lasty;
		}
	else {
		unit[j].transx = 0;
		unit[j].transy = 0;
		}
	}

}

void render() {

int j, k, dx, dy, mx = win_x + vptw + 1, my = win_y + vpth, tx, ty, color;
unitt *u;
float pc;
char buf[BS], buf2[BS];

if (mx > board_w+1) mx = board_w+1;
if (my > board_h+1) my = board_h+1;

clear(buffer);
blit(sidebar, sideframe, 0, 0, 0, 0, vpw, SCREEN_H);

if (n_selected && mode) {
	blit(unit[selected[0]].pic, sideframe, 0, 0, 15, 110, 120, 120);
	textout(sideframe, font, unit[selected[0]].name, 15, 240, _black);

	rectfill(sideframe, 15, 250, 135, 260, _blue);
	pc = (float)(unit[selected[0]].hp) / (float)(unit[selected[0]].shp + unit[selected[0]].shp_bonus);
	if (pc < .5)
		color = _red;
	else if (pc < 1)
		color = _yellow;
	else
		color = _green;
	rectfill(sideframe, 16, 251, 16 + 118 * pc, 259, color);
	textprintf_centre(sideframe, font, 75, 252, _black, "%d/%d", unit[selected[0]].hp, unit[selected[0]].shp + unit[selected[0]].shp_bonus);

	if (unit[selected[0]].smana + unit[selected[0]].smana_bonus) {
		rectfill(sideframe, 15, 262, 135, 272, _blue);
		rectfill(sideframe, 16, 263, 16 + 118 * ((float)(unit[selected[0]].mana) / (float)(unit[selected[0]].smana + unit[selected[0]].smana_bonus)), 271, _red);
		textprintf_centre(sideframe, font, 75, 264, _black, "%d/%d", unit[selected[0]].mana, unit[selected[0]].smana + unit[selected[0]].smana_bonus);
		}

	sprintf(buf, " Damage: %d", unit[selected[0]].dmg_min);
	if (unit[selected[0]].dmg_min != unit[selected[0]].dmg_max) {
		sprintf(buf2, "-%d", unit[selected[0]].dmg_max);
		strcat(buf, buf2);
		}
	if (unit[selected[0]].dmg_bonus) {
		sprintf(buf2, " (%+d)", unit[selected[0]].dmg_bonus);
		strcat(buf, buf2);
		}
	textout(sideframe, font, buf, 15, 277, _black);

	sprintf(buf, "  Armor: %d", unit[selected[0]].armor);
	if (unit[selected[0]].armor_bonus) {
		sprintf(buf2, " (%+d)", unit[selected[0]].armor_bonus);
		strcat(buf, buf2);
		}
	textout(sideframe, font, buf, 15, 287, _black);

	sprintf(buf, "  Speed: %d", unit[selected[0]].speed);
	if (unit[selected[0]].speed_bonus) {
		sprintf(buf2, " (%+d)", unit[selected[0]].speed_bonus);
		strcat(buf, buf2);
		}
	textout(sideframe, font, buf, 15, 297, _black);

	sprintf(buf, "Agility: %d", unit[selected[0]].aspeed);
	if (unit[selected[0]].aspeed_bonus) {
		sprintf(buf2, " (%+d)", unit[selected[0]].aspeed_bonus);
		strcat(buf, buf2);
		}
	textout(sideframe, font, buf, 15, 307, _black);

	sprintf(buf, "  Range: %d", unit[selected[0]].range);
	if (unit[selected[0]].range_bonus) {
		sprintf(buf2, " (%+d)", unit[selected[0]].range_bonus);
		strcat(buf, buf2);
		}
	textout(sideframe, font, buf, 15, 317, _black);

	sprintf(buf, "  Sight: %d", unit[selected[0]].sight);
	if (unit[selected[0]].sight_bonus) {
		sprintf(buf2, " (%+d)", unit[selected[0]].sight_bonus);
		strcat(buf, buf2);
		}
	textout(sideframe, font, buf, 15, 327, _black);
	}
else if (!mode) {
	int max = cmods + EMOD_ROWS;
	max = max > n_emods ? n_emods : max;

	rectfill(sideframe, EMOD_X, EMOD_Y, EMOD_W, EMOD_H, _white);
	for (j = cmods; j < max; ++j)
		textout(sideframe, font, emods[j], 10, 20 + (j-cmods) * 10, (j == cmod ? _red : _black));
	textout(sideframe, font, "Add type", EMOD_X, EMOD_H + 15, _red);
	textout(sideframe, font, "Remove type", EMOD_X, EMOD_H + 25, _red);
	textout(sideframe, font, "New map", EMOD_X, EMOD_H + 35, _red);
	textout(sideframe, font, "Load map", EMOD_X, EMOD_H + 45, _red);
	textout(sideframe, font, "Save map", EMOD_X, EMOD_H + 55, _red);
	textout(sideframe, font, "Exit", EMOD_X, EMOD_H + 65, _red);
	textprintf_centre(sideframe, font, vpx/2, 470, _black, "%d", player);
	textout(sideframe, font, "<<<", (vpx/2) - 40, 470, _green);
	textout(sideframe, font, ">>>", (vpx/2) + 20, 470, _green);
	}

for (j = 0; j < n_buttons; ++j)
	if (j == c_button)
		blit(button[j].pic, sideframe, 0, 0, 11 + BBUFF * (j % BCOLS), 346 + BBUFF * (j / BCOLS), BSIZE-1, BSIZE-1);
	else
		blit(button[j].pic, sideframe, 0, 0, 10 + BBUFF * (j % BCOLS), 345 + BBUFF * (j / BCOLS), BSIZE, BSIZE);

for (j = win_x; j < mx; ++j) {
	for (k = win_y; k <= my; ++k) {
		u = &unit[tile[j][k]];
		blit(u->anim[u->canim].frame[u->panim], map, 0, 0, (j-win_x) * TILE_W, 
(k-win_y) * TILE_H, TILE_W, TILE_H);
		}
	}

for (j = 0; j < LAYER_MAX; ++j) {
	for (k = 0; k < n_unit; ++k) {
		if (unit[k].x != -1 && unit[k].layer == j && unit[k].x + unit[k].w >= win_x && unit[k].x <= win_x + vptw && unit[k].y + unit[k].h
>= win_y && unit[k].y <= win_y + vpth) {
			u = &unit[k];

//			printf("Unit(%d,%s,%d,%d)\t", k, unit[k].name, unit[k].canim, unit[k].panim);
			if (u->r)
				rotate_sprite(map, u->anim[u->canim].frame[u->panim], (u->x - win_x) * 
TILE_W + u->transx, (u->y - win_y) * TILE_H + u->transy, itofix(u->r & 255));				
			else
				draw_sprite(map, u->anim[u->canim].frame[u->panim], (u->x - win_x) * 
TILE_W + u->transx, (u->y - win_y) * TILE_H + u->transy);
//			printf("/Unit\t");
			}
		}
	for (csprite = 0; csprite < n_sprites; ++csprite) {
		do {
			k = n_sprites;
			animate_sprite(csprite);
			} while (k != n_sprites && k < n_sprites);
		if (sprites[csprite].layer == j && sprites[csprite].x + sprites[csprite].w >= win_x * TILE_W && sprites[csprite].x <= win_x * TILE_W + vpw && sprites[csprite].y + sprites[csprite].h
>= win_y * TILE_H && sprites[csprite].y + sprites[csprite].h <= win_y * TILE_H + vph) {
			u = &unit[sprites[csprite].u];

//			printf("Sprite\t");
			if (sprites[csprite].r)
				rotate_sprite(map, u->anim[sprites[csprite].canim].frame[sprites[csprite].panim], sprites[csprite].x - win_x * TILE_W, sprites[csprite].y - win_y * TILE_H, itofix(sprites[csprite].r & 255));
			else
				draw_sprite(map, u->anim[sprites[csprite].canim].frame[sprites[csprite].panim], sprites[csprite].x - win_x * TILE_W, sprites[csprite].y - win_y * TILE_H);
//			printf("/Sprite\t");
			}
		}
	csprite = -1;
	}

for (j = 0; j < n_selected; ++j) {
	if (unit[selected[j]].x >= win_x && unit[selected[j]].x <= win_x + vptw && unit[selected[j]].y >= win_y && unit[selected[j]].y <= win_y + vpth)
		rect(map, (unit[selected[j]].x - win_x) * TILE_W + unit[selected[j]].transx, 
(unit[selected[j]].y - win_y) * TILE_H + unit[selected[j]].transy, (unit[selected[j]].x + 
unit[selected[j]].w - win_x) * TILE_W + unit[selected[j]].transx, (unit[selected[j]].y + 
unit[selected[j]].h - win_y) * TILE_H + unit[selected[j]].transy, (unit[selected[j]].owner ? (unit[selected[j]].owner == player ? _green: _red) : _black));
	}

draw_sprite(buffer, mbuff, 0, 0);
vsync();
blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

}

void set_defaults(unitt *u) {

bzero(u, sizeof(unitt));
u->x = -1;
u->tx = -1;
u->ty = -1;
u->tn = -1;
u->w = 1;
u->h = 1;
u->shp = 1;
u->hp = 1;
u->sight = 1;
u->flags = CREATURE;
u->layer = LAYER_LAND;
u->canim = -1;
u->pic = get_pic("nopic.pcx");

}

int add_unit(char *path) {

xc *x;
char buf[BS];

if (!(x = get_mod(path)))
	return -1;

set_defaults(&unit[n_unit]);
unit[n_unit].mod = x;
do_event(n_unit++, EVENT_INIT);
if (errno) {
	--n_unit;
	sprintf(buf, "Module %s generated error code %d!", path, errno);
	msgbox(buf);
	return -1;
	}

unit[n_unit-1].hp = unit[n_unit-1].shp + unit[n_unit-1].shp_bonus;
unit[n_unit-1].mana = unit[n_unit-1].smana + unit[n_unit-1].smana_bonus;
set_anim(&unit[n_unit-1], 0);

return n_unit-1;

}

void remove_unit(int n) {

int j, k;

for (--n_unit, j = n; j < n_unit; ++j)
	memcpy(&unit[j], &unit[j+1], sizeof(unitt));

for (j = 0; j < board_w; ++j)
	for (k = 0; k < board_h; ++k)
		if (tile[j][k] == n)
			tile[j][k] = 0;

}

void cleanup() {

int j;

for (j = 0; j < n_pics; ++j)
	destroy_bitmap(pics[j]);
for (j = 0; j < n_mods; ++j)
	unload_xc(mods[j]);
for (j = 0; j < n_sounds; ++j)
	destroy_sample(sounds[j]);
for (j = 0; j < n_midis; ++j)
	destroy_midi(midis[j]);

destroy_bitmap(buffer);
destroy_bitmap(mbuff);
destroy_bitmap(sidebar);
allegro_exit();

}

// Begin set_* functions

xc_func(set_umod) {

xc *x;

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

if (x = get_mod(inst_ptr(argv[1]))) {
	unit[argv[0]].mod = x;
	do_event(argv[0], EVENT_INIT);
	return 1;
	}

return 0;

}

xc_func(set_name) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

strcpy(unit[argv[0]].name, inst_ptr(argv[1]));

return 1;

}

xc_func(set_pic) {

BITMAP *bmp;

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

if (bmp = get_pic(inst_ptr(argv[1]))) {
	unit[argv[0]].pic = bmp;
	return 1;
	}
return 0;

}

xc_func(set_loc) {

if (argc < 3)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].x = argv[1];
unit[argv[0]].y = argv[2];

return 1;

}

xc_func(set_size) {

if (argc < 3)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].w = argv[1];
unit[argv[0]].h = argv[2];

return 1;

}

xc_func(set_layer) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].layer = argv[1];

return 1;

}

xc_func(set_hp) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] <= 0)
	return 0;

unit[argv[0]].hp = argv[1];

return 1;

}

xc_func(set_shp) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] <= 0)
	return 0;

unit[argv[0]].shp = argv[1];

return 1;

}

xc_func(set_mana) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] <= 0)
	return 0;

unit[argv[0]].mana = argv[1];

return 1;

}

xc_func(set_smana) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] <= 0)
	return 0;

unit[argv[0]].smana = argv[1];

return 1;

}

xc_func(set_dmg) {

if (argc < 3)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] > argv[2])
	return 0;

unit[argv[0]].dmg_min = argv[1];
unit[argv[0]].dmg_max = argv[2];

return 1;

}

xc_func(set_armor) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].armor = argv[1];

return 1;

}

xc_func(set_speed) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].speed = argv[1];

return 1;

}

xc_func(set_aspeed) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].aspeed = argv[1];

return 1;

}

xc_func(set_range) {


if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].range = argv[1];

return 1;

}

xc_func(set_sight) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].sight = argv[1];

return 1;

}

xc_func(set_flags) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].flags = argv[1];

return 1;

}

xc_func(set_bspeed) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].bspeed = argv[1];

return 1;

}

xc_func(set_custom) {

if (argc < 3)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= MAX_CUSTOM)
	return 0;

unit[argv[0]].custom[argv[1]] = argv[2];

return 1;

}

xc_func(set_owner) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].owner = argv[1];

return 1;

}

xc_func(set_r) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].r = argv[1];

return 1;

}

// Begin get_* functions

xc_func(get_owner) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].owner;

}

xc_func(get_umod) {

int j;

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

for (j = 0; j < n_mods; ++j)
	if (mods[j] == unit[argv[0]].mod) {
		strcpy(str_out, modnames[j]);
		return 1;
		}

return 0;

}

xc_func(_get_pic) {

int j;

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

for (j = 0; j < n_pics; ++j)
	if (pics[j] == unit[argv[0]].pic) {
		strcpy(str_out, picnames[j]);
		return 1;
		}

return 0;

}

xc_func(get_name) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

strcpy(str_out, unit[argv[0]].name);
return 1;

}

xc_func(get_flags) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].flags;

}

xc_func(get_layer) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].layer;

}

xc_func(get_x) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].x;

}

xc_func(get_y) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].y;

}

xc_func(get_w) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].w;

}

xc_func(get_h) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].h;

}

xc_func(get_hp) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].hp;

}

xc_func(get_shp) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].shp;

}

xc_func(get_mana) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].mana;

}

xc_func(get_smana) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].smana;

}

xc_func(get_dmg_min) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].dmg_min;

}

xc_func(get_dmg_max) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].dmg_max;

}

xc_func(get_dmg_bonus) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].dmg_bonus;

}

xc_func(get_armor) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].armor;

}

xc_func(get_armor_bonus) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].armor_bonus;

}

xc_func(get_speed) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].speed;

}

xc_func(get_speed_bonus) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].speed_bonus;

}

xc_func(get_aspeed) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].aspeed;

}

xc_func(get_aspeed_bonus) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].aspeed_bonus;

}

xc_func(get_bspeed_bonus) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].bspeed_bonus;

}

xc_func(get_range) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].range;

}

xc_func(get_range_bonus) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].range_bonus;

}

xc_func(get_sight) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].sight;

}

xc_func(get_sight_bonus) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].sight_bonus;

}

xc_func(get_shp_bonus) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].shp_bonus;

}

xc_func(get_smana_bonus) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].smana_bonus;

}

xc_func(get_bspeed) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].bspeed;

}

xc_func(get_custom) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= MAX_CUSTOM)
	return 0;

return unit[argv[0]].custom[argv[1]];

}

xc_func(get_r) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].r;

}

// Begin animation functions

xc_func(get_anim) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].canim;

}

xc_func(add_anim) {

int j;
BITMAP *bmp;

if (argc < 5)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= MAX_ANIM || argv[2] < 0 || argv[3] < -1)
	return 0;

unit[argv[0]].anim[argv[1]].n_frames = argc - 4;
unit[argv[0]].anim[argv[1]].speed = argv[2];
unit[argv[0]].anim[argv[1]].loop = argv[3];
unit[argv[0]].anim[argv[1]].w = 1;
unit[argv[0]].anim[argv[1]].h = 1;
for (j = 4; j < argc; ++j) {
	if (!(bmp = get_pic(inst_ptr(argv[j]))))
		return 0;
	unit[argv[0]].anim[argv[1]].frame[j-4] = bmp;
	if (bmp->w > unit[argv[0]].anim[argv[1]].w)
		unit[argv[0]].anim[argv[1]].w = bmp->w;
	if (bmp->h > unit[argv[0]].anim[argv[1]].h)
		unit[argv[0]].anim[argv[1]].h = bmp->h;
	}

return 1;

}

xc_func(copy_anim) {

int j;

if (argc < 3)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= MAX_ANIM || argv[2] < 0 || argv[2] >= MAX_ANIM)
	return 0;

memcpy(&(unit[argv[0]].anim[argv[1]]), &(unit[argv[0]].anim[argv[2]]), sizeof(animt));

return 1;

}

xc_func(_set_anim) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

if (argc > 2)
	unit[argv[0]].ae = argv[2];
else
	unit[argv[0]].ae = 0;
set_anim(&unit[argv[0]], argv[1]);

return 1;

}

// Begin button functions

xc_func(set_buttons) {

int j;
BITMAP *bmp;

if (argc % 2)
	return 0;

n_buttons = 0;
for (j = 0; j < argc; ++j) {
	if (!(bmp = get_pic(inst_ptr(argv[j]))))
		return 0;
	button[n_buttons].pic = bmp;
	button[n_buttons++].event = argv[++j];
	}

return 1;

}

// Begin building functions

xc_func(start_build) {

int n;

if (argc < 5)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[2] < 0)
	return 0;

if ((n = add_unit(inst_ptr(argv[1]))) == -1)
	return 0;

if (argv[2] > board_w - unit[n].w || argv[3] > board_h - unit[n].h)
	return 0;

if (!check_loc(n, argv[2], argv[3]))
	return 0;

unit[n].x = argv[2];
unit[n].y = argv[3];
unit[n].owner = unit[argv[0]].owner;
do_event(n, EVENT_STAND);
unit[n].hp = 1;

unit[argv[0]].tx = -1;
unit[argv[0]].ty = -1;
unit[argv[0]].tn = n;
unit[argv[0]].tr = 1;
unit[argv[0]].e = argv[4];

return 1;

}

xc_func(repair) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= n_unit)
	return 0;

if (unit[argv[1]].flags & BUILDING) {
	unit[argv[1]].hp += unit[argv[0]].bspeed + unit[argv[0]].bspeed_bonus;
	check_death(argv[1]);
	if (unit[argv[1]].hp == unit[argv[1]].shp + unit[argv[1]].shp_bonus)
		unit[argv[1]].flags |= COMPLETED;
	}
else
	return 0;

return 1;

}

xc_func(train_unit) {

int n, j, s, b, m = (board_w > board_h ? board_w : board_h);

if (argc < 2)
	return -1;

if (argv[0] < 0 || argv[0] >= n_unit)
	return -1;

if ((n = add_unit(inst_ptr(argv[1]))) == -1)
	return -1;

unit[n].owner = unit[argv[0]].owner;
do_event(n, EVENT_STAND);

for (b = 0; b < m; ++b) {
	for (s = unit[argv[0]].x + unit[argv[0]].w + b, j = unit[argv[0]].x - 1 - b; j <= s; ++j) {
		if (check_loc(n, j, unit[argv[0]].y - 1 - b)) {
			unit[n].x = j;
			unit[n].y = unit[argv[0]].y - 1 - b;
			return n;
			}
		}
	for (s = unit[argv[0]].y + unit[argv[0]].h + b, j = unit[argv[0]].y - 1 - b; j <= s; ++j) {
		if (check_loc(n, unit[argv[0]].x + unit[argv[0]].w + b, j)) {
			unit[n].x = unit[argv[0]].x + unit[argv[0]].w + b;
			unit[n].y = j;
			return n;
			}
		}
	for (s = unit[argv[0]].x - 1 - b, j = unit[argv[0]].x + unit[argv[0]].w + b; j >= s; --j) {
		if (check_loc(n, j, unit[argv[0]].y + unit[argv[0]].h + b)) {
			unit[n].x = j;
			unit[n].y = unit[argv[0]].y + unit[argv[0]].h + b;
			return n;
			}
		}
	for (s = unit[argv[0]].y - 1 - b, j = unit[argv[0]].y + unit[argv[0]].h + b; j >= s; --j) {
		if (check_loc(n, unit[argv[0]].x - 1 - b, j)) {
			unit[n].x = unit[argv[0]].x - 1 - b;
			unit[n].y = j;
			return n;
			}
		}
	}

return n;

}

xc_func(start_upgrade) {

if (argc < 3)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0)
	return 0;

unit[argv[0]].mana = 0;
unit[argv[0]].smana = argv[1];
unit[argv[0]].taske = argv[2];
if (n_selected == 1 && selected[0] == argv[0]) n_buttons = 0;

return 1;

}

// Begin input functions

xc_func(set_select) {

if (argc < 2)
	return 0;

selmode = argv[0];
sele = argv[1];

return 1;

}

// Begin low-level AI functions

xc_func(target_loc) {

if (argc < 3)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= board_w || argv[2] < 0 || argv[2] >= board_h)
	return 0;

unit[argv[0]].tn = -1;
unit[argv[0]].tx = argv[1];
unit[argv[0]].ty = argv[2];
if (argc >= 4)
	unit[argv[0]].e = argv[3];
else
	unit[argv[0]].e = 0;

return 1;

}

xc_func(target_unit) {

if (argc < 3)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= n_unit || argv[2] < 0)
	return 0;

unit[argv[0]].tn = argv[1];
unit[argv[0]].tr = argv[2];
unit[argv[0]].tx = -1;
unit[argv[0]].ty = -1;
if (argc >= 4)
	unit[argv[0]].e = argv[3];
else
	unit[argv[0]].e = 0;

return 1;

}

xc_func(target_attack) {

if (argc < 3)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= n_unit)
	return 0;

unit[argv[0]].tn = argv[1];
unit[argv[0]].tr = unit[argv[0]].range + unit[argv[0]].range_bonus;
unit[argv[0]].tx = -1;
unit[argv[0]].ty = -1;
unit[argv[0]].e = argv[2];

return 1;

}

// Begin unit action handling functions

xc_func(check_aspeed) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

return unit[argv[0]].asp >= unit[argv[0]].aspeed + unit[argv[0]].aspeed_bonus;

}

xc_func(reset_aspeed) {

if (argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].asp = 0;
return 1;

}

// Begin damage dealing functions

xc_func(_attack_unit) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= n_unit)
	return 0;

attack_unit(argv[0], argv[1]);
check_death(argv[1]);

return 1;

}

xc_func(dmg_unit) {

if (argc < 3)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= n_unit)
	return 0;

if (argv[2] > unit[argv[1]].armor + unit[argv[1]].armor_bonus) {
	unit[argv[1]].hp -= argv[2] - unit[argv[1]].armor - unit[argv[1]].armor_bonus;
	do_event3(argv[1], EVENT_DAMAGED, argv[0], argv[2] - unit[argv[1]].armor - unit[argv[1]].armor_bonus);
	check_death(argv[1]);
	}

return 1;

}

// Begin upgrade/bonus handling functions

xc_func(add_upgrade) {

int j;

if (!argc)
	return 0;

upgrades[n_upgrades].mod = xi->parent;
upgrades[n_upgrades++].e = argv[0];
for (j = 0; j < n_unit; ++j) {
	unit[j].dmg_bonus = 0;
	unit[j].armor_bonus = 0;
	unit[j].speed_bonus = 0;
	unit[j].aspeed_bonus = 0;
	unit[j].bspeed_bonus = 0;
	unit[j].range_bonus = 0;
	unit[j].sight_bonus = 0;
	unit[j].shp_bonus = 0;
	unit[j].smana_bonus = 0;
	}
do_event_all(EVENT_UPGRADE);

return 1;

}

xc_func(do_upgrades) {

int j, k;
xc *x;

if (argc < 2)
	return 0;

if (!(x = get_mod(inst_ptr(argv[1]))))
	return 0;

for (j = 0; j < n_upgrades; ++j) {
	if (upgrades[j].mod == x) {
		if (argc == 2)
			run_xc_mono(x, MEMSZ, 2, argv[0], (int64)upgrades[j].e);
		else {
			for (k = 2; k < argc; ++k) {
				if (upgrades[j].e == argv[k]) {
					run_xc_mono(x, MEMSZ, 2, argv[0], (int64)upgrades[j].e);
					break;
					}
				}
			}
		}
	}

return 1;

}

xc_func(poll_upgrades) {

int j, k;
xc *x;

if (argc < 2)
	return -1;

if (!(x = get_mod(inst_ptr(argv[1]))))
	return -1;

for (j = 0; j < n_upgrades; ++j) {
	if (upgrades[j].mod == x) {
		if (argc == 2)
			return 1;
		else {
			for (k = 2; k < argc; ++k) {
				if (upgrades[j].e == argv[k])
					return 1;
				}
			}
		}
	}

return 0;

}

xc_func(give_dmg_bonus) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].dmg_bonus += argv[1];

return 1;

}

xc_func(give_armor_bonus) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].armor_bonus += argv[1];

return 1;

}

xc_func(give_speed_bonus) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].speed_bonus += argv[1];

return 1;


}

xc_func(give_aspeed_bonus) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].aspeed_bonus += argv[1];

return 1;

}

xc_func(give_bspeed_bonus) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].bspeed_bonus += argv[1];

return 1;

}

xc_func(give_range_bonus) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].range_bonus += argv[1];

return 1;

}

xc_func(give_sight_bonus) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].sight_bonus += argv[1];

return 1;

}

xc_func(give_shp_bonus) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].shp_bonus += argv[1];

return 1;

}

xc_func(give_smana_bonus) {

if (argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit)
	return 0;

unit[argv[0]].smana_bonus += argv[1];

return 1;

}

// Begin distance and location calculation functions

xc_func(_dist) {

if (argc < 4)
	return -1;

return sqrt((argv[0] - argv[2])*(argv[0] - argv[2]) + (argv[1] - argv[3])*(argv[1] - argv[3]));

}

xc_func(udist) {

if (argc < 2)
	return -1;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= n_unit)
	return -1;

return unit_dist(argv[0], argv[1]);

}

xc_func(ldist) {

if (argc < 3)
	return -1;

if (argv[0] < 0 || argv[0] >= n_unit)
	return -1;

return dist(unit[argv[0]].x, unit[argv[0]].y, unit[argv[0]].w, unit[argv[0]].h, argv[1], argv[2], 1, 1);

}

xc_func(pix_to_loc_x) {

if (argc < 1)
	return 0;

return argv[0] / TILE_W;

}

xc_func(pix_to_loc_y) {

if (argc < 1)
	return 0;

return argv[0] / TILE_H;

}

xc_func(loc_to_pix_x) {

if (argc < 1)
	return 0;

return argv[0] * TILE_W;

}

xc_func(loc_to_pix_y) {

if (argc < 1)
	return 0;

return argv[0] * TILE_H;

}

xc_func(get_angle) {

int i, x, y;

if (argc < 4)
	return 0;

if (argv[2] == argv[0]) {
	if (argv[1] == argv[3])
		return 0;
	else if (argv[1] > argv[3])
		return 192;
	else
		return 64;
	}
else if (argv[1] == argv[3]) {
	if (argv[2] > argv[0])
		return 0;
	else
		return 128;
	}
else {
	i = atan((double)(y = argv[1] - argv[3]) / (double)(x = argv[2] - argv[0])) / (2*PI) * 255;
	if (x > 0 && y > 0)
		return i + 192;
	else if (x < 0 && y > 0)
		return i + 192;
	else if (x < 0 && y < 0)
		return i + 64;
	else
		return i + 64;
	}

}

// Begin timer functions

xc_func(add_timer) {

if (argc < 4)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[2] < -1 || !argv[3])
	return;

if (argc >= 5)
	if (argv[4] < 0 || argv[4] >= n_unit)
		return 0;

timers[n_timers].mod = unit[argv[0]].mod;
timers[n_timers].speed = argv[1];
timers[n_timers].loop = argv[2];
timers[n_timers].tick = 0;
timers[n_timers].e = argv[3];
timers[n_timers].u = argv[0];
if (argc >= 5)
	timers[n_timers].tx = argv[4];
else
	timers[n_timers].tx = 0;
if (argc >= 6)
	timers[n_timers++].ty = argv[5];
else
	timers[n_timers++].ty = 0;

return 1;

}

xc_func(stop_timer) {

if (ctimer < 0)
	return 0;

_remove_timer(ctimer);

return 1;

}

xc_func(set_timer_custom) {

if (ctimer < 0 || argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= MAX_CUSTOM)
	return 0;

timers[ctimer].custom[argv[0]] = argv[1];

return 1;

}

xc_func(set_timer_t) {

if (ctimer < 0 || argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= MAX_CUSTOM)
	return 0;

timers[ctimer].tx = argv[0];
if (argc >= 2)
	timers[ctimer].ty = argv[1];

return 1;

}

xc_func(get_timer_custom) {

if (ctimer < 0 || argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= MAX_CUSTOM)
	return 0;

return timers[ctimer].custom[argv[0]];

}

xc_func(get_timer_tx) {

if (ctimer < 0)
	return 0;

return timers[ctimer].tx;

}

xc_func(get_timer_ty) {

if (ctimer < 0)
	return 0;

return timers[ctimer].ty;

}

// Begin non-unit sprite functions

xc_func(add_sprite) {

if (argc < 4)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0 || argv[1] >= MAX_ANIM)
	return 0;

sprites[n_sprites].u = argv[0];
sprites[n_sprites].canim = argv[1];
sprites[n_sprites].x = argv[2];
sprites[n_sprites].y = argv[3];
sprites[n_sprites].panim = 0;
sprites[n_sprites].size = unit[argv[0]].anim[argv[1]].n_frames;
sprites[n_sprites].speed = unit[argv[0]].anim[argv[1]].speed;
sprites[n_sprites].tick = 0;
sprites[n_sprites].loop = unit[argv[0]].anim[argv[1]].loop;
sprites[n_sprites].w = unit[argv[0]].anim[argv[1]].w;
sprites[n_sprites].h = unit[argv[0]].anim[argv[1]].h;
if (argc >= 6)
	sprites[n_sprites].tx = argv[5];
else
	sprites[n_sprites].tx = 0;
if (argc >= 7)
	sprites[n_sprites].ty = argv[6];
else
	sprites[n_sprites].ty = 0;
if (argc >= 8)
	sprites[n_sprites].layer = argv[7];
else
	sprites[n_sprites].layer = LAYER_LAND;
if (argc >= 9)
	sprites[n_sprites].r = argv[8];
else
	sprites[n_sprites].r = 0;
if (argc >= 5)
	sprites[n_sprites++].e = argv[4];
else
	sprites[n_sprites++].e = 0;

return 1;

}

xc_func(stop_sprite) {

if (csprite < 0)
	return 0;

remove_sprite(csprite);

return 1;

}

xc_func(move_sprite) {

if (csprite < 0 || argc < 2)
	return 0;

sprites[csprite].x = argv[0];
sprites[csprite].y = argv[1];

return 1;

}

xc_func(set_sprite_r) {

if (csprite < 0 || argc < 1)
	return 0;

sprites[csprite].r = argv[0];

return 1;

}

xc_func(set_sprite_custom) {

if (csprite < 0 || argc < 2)
	return 0;

if (argv[0] < 0 || argv[0] >= MAX_CUSTOM)
	return 0;

sprites[csprite].custom[argv[0]] = argv[1];

return 1;

}

xc_func(set_sprite_t) {

if (csprite < 0 || argc < 1)
	return 0;

sprites[csprite].tx = argv[0];
if (argc >= 2)
	sprites[csprite].ty = argv[1];

return 1;

}

xc_func(get_sprite_x) {

if (csprite < 0)
	return 0;

return sprites[csprite].x;

}

xc_func(get_sprite_y) {

if (csprite < 0)
	return 0;

return sprites[csprite].y;

}

xc_func(get_sprite_r) {

if (csprite < 0)
	return 0;

return sprites[csprite].r;

}

xc_func(get_sprite_custom) {

if (csprite < 0 || argc < 1)
	return 0;

if (argv[0] < 0 || argv[0] >= MAX_CUSTOM)
	return 0;

return sprites[csprite].custom[argv[0]];

return 1;

}

xc_func(get_sprite_tx) {

if (csprite < 0)
	return 0;

return sprites[csprite].tx;

}

xc_func(get_sprite_ty) {

if (csprite < 0)
	return 0;

return sprites[csprite].ty;

}

// Begin string handling functions

xc_func(_strcmp) {

if (argc < 2)
	return 0;

return strcmp(inst_ptr(argv[0]), inst_ptr(argv[1]));

}

// Begin output functions

xc_func(_msgbox) {

if (!argc)
	return 0;

msgbox(inst_ptr(argv[0]));

return 1;

}

// Begin sound functions

xc_func(play_sound) {

SAMPLE *s;

if (argc < 1)
	return 0;

if (!(s = get_sound(inst_ptr(argv[0]))))
	return 0;

play_sample(s, (argc >= 2 ? argv[1] : 255), (argc >= 3 ? argv[2] : 128), 1000, 0);

return 1;

}

xc_func(_play_midi) {

MIDI *s;

if (argc < 1)
	return 0;

if (!(s = get_midi(inst_ptr(argv[0]))))
	return 0;

play_midi(s, (argc >= 2 ? argv[1] : 1));

return 1;

}

// Begin utility functions

xc_func(_random) {

if (argc < 2)
	return 0;

if (argv[1] > argv[0]) {
	int64 t = argv[1];
	argv[1] = argv[0];
	argv[0] = t;
	}

if (argv[0] == argv[1])
	return argv[0];
else
	return argv[0] + rand() % (argv[1] - argv[0]);

}

xc_func(do_radius) {

int j;

if (argc < 5)
	return 0;

if (argv[0] < 0 || argv[0] >= n_unit || argv[1] < 0)
	return 0;

for (j = 0; j < n_unit; ++j)
	if (dist(unit[j].x, unit[j].y, unit[j].w, unit[j].h, argv[2], argv[3], 1, 1) <= argv[1])
		do_event2(argv[0], argv[4], j);

return 1;

}

void main() {

int j, k, i, max;
char f;
char buf[BS], *cp;
BITMAP *bmp;
xc *xm;
FILE *fl;

vptw = vpw / TILE_W;
vpth = vph / TILE_H;
m_win_x = board_w - vptw;
m_win_y = board_h - vpth;
srand(time(0));

getcwd(basepath, 80);
normalize(basepath);
strcat(basepath, "/");

allegro_init();
set_color_depth(16);
if (set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0) < 0) {
	allegro_exit();
	puts("Error initializing 16-bit 640x480 display");
	puts(allegro_error);
	exit(1);
	}
if (install_timer() == -1) {
	allegro_exit();
	puts("Error installing timer support");
	puts(allegro_error);
	exit(1);
	}
if (install_mouse() == -1) {
	allegro_exit();
	puts("Error installing mouse support");
	puts(allegro_error);
	exit(1);
	}
if (install_keyboard() == -1) {
	allegro_exit();
	puts("Error installing keyboard support");
	puts(allegro_error);
	exit(1);
	}
if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL) == -1)
	soundf = 0;

atexit(cleanup);

xc_export_var(str_out, XC_TYPE_CHAR, BS);

xc_export_func(set_umod);
xc_export_func(set_name);
xc_export_func(set_flags);
xc_export_func(set_layer);
xc_export_func(set_pic);
xc_export_func(set_loc);
xc_export_func(set_size);
xc_export_func(set_shp);
xc_export_func(set_hp);
xc_export_func(set_smana);
xc_export_func(set_mana);
xc_export_func(set_dmg);
xc_export_func(set_armor);
xc_export_func(set_speed);
xc_export_func(set_aspeed);
xc_export_func(set_bspeed);
xc_export_func(set_range);
xc_export_func(set_sight);
xc_export_func(set_custom);
xc_export_func(set_owner);
xc_export_func(set_r);

xc_export_func(get_umod);
xc_export_func(get_name);
xc_export_func(get_flags);
xc_export_func(get_layer);
xc_export_func(_get_pic);
xc_export_func(get_x);
xc_export_func(get_y);
xc_export_func(get_w);
xc_export_func(get_h);
xc_export_func(get_shp);
xc_export_func(get_hp);
xc_export_func(get_smana);
xc_export_func(get_mana);
xc_export_func(get_dmg_min);
xc_export_func(get_dmg_max);
xc_export_func(get_armor);
xc_export_func(get_speed);
xc_export_func(get_aspeed);
xc_export_func(get_bspeed);
xc_export_func(get_range);
xc_export_func(get_sight);
xc_export_func(get_custom);
xc_export_func(get_owner);
xc_export_func(get_dmg_bonus);
xc_export_func(get_armor_bonus);
xc_export_func(get_speed_bonus);
xc_export_func(get_aspeed_bonus);
xc_export_func(get_bspeed_bonus);
xc_export_func(get_range_bonus);
xc_export_func(get_sight_bonus);
xc_export_func(get_shp_bonus);
xc_export_func(get_smana_bonus);
xc_export_func(get_r);

xc_export_func(add_anim);
xc_export_func(_set_anim);
xc_export_func(copy_anim);
xc_export_func(get_anim);

xc_export_func(set_buttons);

xc_export_func(start_build);
xc_export_func(repair);
xc_export_func(train_unit);
xc_export_func(start_upgrade);

xc_export_func(set_select);

xc_export_func(target_loc);
xc_export_func(target_unit);
xc_export_func(target_attack);

xc_export_func(check_aspeed);
xc_export_func(reset_aspeed);

xc_export_func(_attack_unit);
xc_export_func(dmg_unit);

xc_export_func(add_upgrade);
xc_export_func(do_upgrades);
xc_export_func(poll_upgrades);
xc_export_func(give_dmg_bonus);
xc_export_func(give_armor_bonus);
xc_export_func(give_speed_bonus);
xc_export_func(give_aspeed_bonus);
xc_export_func(give_bspeed_bonus);
xc_export_func(give_range_bonus);
xc_export_func(give_sight_bonus);
xc_export_func(give_shp_bonus);
xc_export_func(give_smana_bonus);

xc_export_func(_dist);
xc_export_func(udist);
xc_export_func(ldist);
xc_export_func(pix_to_loc_x);
xc_export_func(pix_to_loc_y);
xc_export_func(loc_to_pix_x);
xc_export_func(loc_to_pix_y);
xc_export_func(get_angle);

xc_export_func(add_timer);
xc_export_func(stop_timer);
xc_export_func(set_timer_custom);
xc_export_func(set_timer_t);
xc_export_func(get_timer_custom);
xc_export_func(get_timer_tx);
xc_export_func(get_timer_ty);

xc_export_func(add_sprite);
xc_export_func(stop_sprite);
xc_export_func(move_sprite);
xc_export_func(set_sprite_r);
xc_export_func(set_sprite_custom);
xc_export_func(set_sprite_t);
xc_export_func(get_sprite_x);
xc_export_func(get_sprite_y);
xc_export_func(get_sprite_r);
xc_export_func(get_sprite_custom);
xc_export_func(get_sprite_tx);
xc_export_func(get_sprite_ty);

xc_export_func(_strcmp);

xc_export_func(_msgbox);

xc_export_func(play_sound);
xc_export_func(_play_midi);

xc_export_func(_random);
xc_export_func(do_radius);

text_mode(-1);

init_bmp(screen);
buffer = create_bitmap(SCREEN_W, SCREEN_H);
init_bmp(buffer);
sideframe = create_sub_bitmap(buffer, 0, 0, vpx, SCREEN_H);
init_bmp(sideframe);
map = create_sub_bitmap(buffer, vpx, 0, SCREEN_W-vpx, SCREEN_H);
init_bmp(map);

mbuff = create_bitmap(SCREEN_W, SCREEN_H);
init_bmp(mbuff);
clear_to_color(mbuff, MASK_COLOR_16);

_red = makecol16(255, 0, 0);
_green = makecol16(0, 128, 0);
_blue = makecol16(0, 0, 255);
_yellow = makecol16(0, 255, 128);
_white = makecol16(255, 255, 255);
_black = makecol16(0, 0, 0);

// Main menu

mmenu = load_bitmap("menu.pcx", NULL);

n_emods = 1;
cmod = 0;
strcpy(emods[0], "Erase");
//strcpy(emods[1], "mods/bob.xc");
//strcpy(emods[2], "mods/gfarm.xc");
//strcpy(emods[3], "mods/tank.xc");

Main_Menu:

n_menu = 3;
strcpy(menu[0].txt, "Play");
menu[0].x = 400;
menu[0].y = 200;
menu[0].w = 432;
menu[0].h = 208;
strcpy(menu[1].txt, "Edit");
menu[1].x = 400;
menu[1].y = 210;
menu[1].w = 432;
menu[1].h = 218;
strcpy(menu[2].txt, "Exit");
menu[2].x = 400;
menu[2].y = 220;
menu[2].w = 432;
menu[2].h = 228;

show_mouse(mbuff);
cmenu = -1;
while (!key[KEY_ENTER]) {
	blit(mmenu, buffer, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	for (j = 0; j < n_menu; ++j)
		textout(buffer, font, menu[j].txt, menu[j].x, menu[j].y, _red);
	draw_sprite(buffer, mbuff, 0, 0);

	if (mouse_b) {
		if (cmenu == -1) {
			cmenu = -2;
			for (j = 0; j < n_menu; ++j)
				if (mouse_x >= menu[j].x && mouse_x <= menu[j].w && mouse_y >= menu[j].y && mouse_y <= menu[j].h)
					cmenu = j;
			}
		}
	else if (cmenu != -1) {
		if (cmenu > -2) {
			if (mouse_x >= menu[cmenu].x && mouse_x <= menu[cmenu].w && mouse_y >= menu[cmenu].y && mouse_y <= menu[cmenu].h) {
				switch (cmenu) {
					case 0:
						mode = MODE_PLAY;
						goto Start_Play;
					case 1:
						mode = MODE_EDIT;
						goto Start_Play;
					case 2:
						exit(0);
					}
				}
			}
		cmenu = -1;
		}

	vsync();
	show_mouse(NULL);
	blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	show_mouse(mbuff);
	}

if (key[KEY_ENTER])
	exit(0);

Start_Play:

// Test init section

sidebar = load_pcx("sidebar.pcx", NULL);

bzero(unit, MAX_UNIT * sizeof(unitt));
n_unit = 0;
add_unit("mods/blank.xc");
//for (j = 0; j < n_emods; ++j)
//	set_anim(&unit[esamp[j] = add_unit(emods[j])], 0);

/*if ((j = add_unit("mods/green.xc")) != -1) {
	set_anim(&unit[j], 0);
	}
else {
	printf("Error with green!");
	exit(1);
	}

if ((j = add_unit("mods/bob.xc")) != -1) {
	set_anim(&unit[j], 0);
	unit[j].owner = 1;
	}
else {
	printf("Error with bob!");
	exit(1);
	}

if ((j = add_unit("mods/bob.xc")) != -1) {
	set_anim(&unit[j], 0);
	strcpy(unit[j].name, "Evil bob!");
	unit[j].owner = 2;
	}
else {
	printf("Error with bob!");
	exit(1);
	}

if ((j = add_unit("mods/gfarm.xc")) != -1) {
	set_anim(&unit[j], 0);
	unit[j].owner = 1;

	unit[j].x = 6;
	unit[j].y = 6;
	unit[j].flags |= COMPLETED;
	}
else {
	printf("Error with goat farm!");
	exit(1);
	}

if ((j = add_unit("mods/tank.xc")) != -1) {
	unit[j].owner = 1;

	unit[j].x = 6;
	unit[j].y = 8;
	}
else {
	printf("Error with tank!");
	exit(1);
	}*/

n_buttons = 0;

for (j = 0; j < board_w; ++j)
	for (k = 0; k < board_h; ++k)
		tile[j][k] = 0;

show_mouse(mbuff);

if (mode)
	if (!load_map())
		goto Main_Menu;

player = 1;
c_button = -1;
while (!key[KEY_ESC]) {
	if ((!mouse_x || key[KEY_LEFT]) && win_x) {
		--win_x;
		}

	else if ((mouse_x == SCREEN_W-1 || key[KEY_RIGHT]) && win_x < m_win_x) {
		++win_x;
		}
	if ((!mouse_y || key[KEY_UP]) && win_y) {
		--win_y;
		}
	else if ((mouse_y == SCREEN_H-1 || key[KEY_DOWN]) && win_y < m_win_y) {
		++win_y;
		}
	if (mouse_b & 1) {
		if (!mode) {
			if (mouse_x < vpx && mouse_x >= EMOD_X && mouse_x <= EMOD_W) {
				if (mouse_y >= EMOD_Y && mouse_y <= EMOD_H) {
					max = EMOD_ROWS - cmods;
					max = max > n_emods ? n_emods : max;
	
					for (j = 0; j < max; ++j)
						if (mouse_y >= 20 + j * 10 && mouse_y <= 30 + j * 10)
							cmod = cmods + j;
					}
				else if (mouse_y >= EMOD_H + 15) {
					if (mouse_x >= (vpx/2) - 40 && mouse_x <= (vpx/2) - 10 && mouse_y >= 470)
						c_button = 50;
					else if (mouse_x >= (vpx/2) + 20 && mouse_x <= (vpx/2) + 50 && mouse_y >= 470)
						c_button = 51;
					else if (mouse_y <= EMOD_H + 75)
						c_button = (mouse_y - (EMOD_H+15)) / 10;
					}
				}
			else {
				mx = (mouse_x - vpx) / TILE_W + win_x;
				my = (mouse_y - vpy) / TILE_H + win_y;
				if (cmod) {
					f = 1;
					for (j = 0; j < n_unit; ++j)
						if (mx + unit[esamp[cmod]].w - 1 >= unit[j].x && mx <= unit[j].x + unit[j].w - 1 && my + unit[esamp[cmod]].h - 1 >= unit[j].y && my <= unit[j].y + unit[j].h - 1) {
							f = 0;
							break;
							}

					if (f) {
						if ((i = add_unit(emods[cmod])) == -1) {
							msgbox("Error adding unit");
							}
						else {
							unit[i].owner = player;
							unit[i].x = mx;
							unit[i].y = my;
							}
						}
					}
				else {
					for (j = 0; j < n_unit; ++j) {
						if (mx >= unit[j].x && mx <= unit[j].x + unit[j].w - 1 && my >= unit[j].y && my <= unit[j].y + unit[j].h - 1) {
							--n_unit;
							for (k = j; k < n_unit; ++k)
								memcpy(&unit[k], &unit[k+1], sizeof(unitt)); 
							--j;
							}
						}
					}
				}
			}
		else if (!mx) {
			mx = mouse_x;
			my = mouse_y;
			}
		}
	else if (mx && mode) {
		f = 1;
		for (j = 0; j < n_buttons; ++j) {
			if (mx >= 11 + BBUFF * (j % BCOLS) && mx <= 11 + BBUFF * (j % BCOLS) + BSIZE-1 && my >= 346 + BBUFF * (j / BCOLS) && my <= 346 + BBUFF * (j / BCOLS) + BSIZE-1) {
				f = 0;
				c_button = j;
				break;
				}
			}
		if (f) {
			for (j = 0; j < n_unit; ++j) {
				if (unit[j].hp && unit[j].x != -1 && mx >= vpx + (unit[j].x - win_x) * TILE_W && mx <= vpx + (unit[j].x + unit[j].w - win_x) * TILE_W && my >= vpy + (unit[j].y - win_y) * TILE_H && my <= vpy + (unit[j].y + unit[j].h - win_y) * TILE_H) {
					if (!selmode) {
						f = 0;
						if (key_shifts && KB_SHIFT_FLAG) {
							selected[n_selected++] = j;
							n_buttons = 0;
							}
						else {
							n_selected = 1;
							selected[0] = j;
							if (!(unit[j].flags & BUILDING) || (unit[j].flags & COMPLETED && !unit[j].smana))
								do_event(j, EVENT_SELECT);
							else
								n_buttons = 0;
							}
						}
					else if (selmode & SEL_UNIT) {
						f = 0;
						selmode = 0;
						do_event2_selected(sele, j);
						}
					break;
					}
				}
			}
		if (f && (selmode & SEL_LOC) && mx >= vpx) {
			selmode = 0;
			do_event3_selected(sele, (mx - vpx) / TILE_W + win_x, (my - vpy) / TILE_H + win_y);
			}
		mx = 0;
		}
	else if (c_button != -1) {
		if (mode) {
			for (j = 0; j < n_buttons; ++j) {
				if (j == c_button && mouse_x >= 11 + BBUFF * (j % BCOLS) && mouse_x <= 11 + BBUFF * (j % BCOLS) + BSIZE-1 && mouse_y >= 346 + BBUFF * (j / BCOLS) && mouse_y <= 346 + BBUFF * (j / BCOLS) + BSIZE-1) {
					selmode = 0;
					do_event_selected(button[c_button].event);
					break;
					}
				}
			}
		else {
			if (c_button == 50) {
				if (mouse_x >= (vpx/2) - 40 && mouse_x <= (vpx/2) - 10 && mouse_y >= 470)
					player = --player & 255;
				}
			else if (c_button == 51) {
				if (mouse_x >= (vpx/2) + 20 && mouse_x <= (vpx/2) + 50 && mouse_y >= 470)
					player = ++player & 255;
				}
			else if (mouse_x < vpx && (mouse_y - (EMOD_H+15)) / 10 == c_button) {
				switch (c_button) {
					case 0:
						buf[0] = '\0';
						if (file_select("Add unit type module", buf, "XC")) {
							normalize(buf);
							remove_bp(buf);

							f = 0;
							for (j = 1; j < n_emods; ++j) {
								if (!strcmp(buf, emods[j])) {
									f = 1;
									break;
									}
								}

							if (f);
							else if ((k = add_unit(buf)) == -1) {
								msgbox("Error in module");
								}
							else {
								strcpy(emods[n_emods], buf);
								esamp[n_emods++] = k;
								}
							}
						text_mode(-1);
						show_mouse(mbuff);
						break;
					case 1:
						if (cmod) {
							xm = get_mod(emods[cmod]);
							for (j = 0; j < n_unit; ++j) {
								if (unit[j].mod == xm) {
									remove_unit(j);
									--j;
									}
								}
							for (--n_emods, j = cmod; j < n_emods; ++j) {
								strcpy(emods[j], emods[j+1]);
								esamp[j] = esamp[j+1];
								}
							if (cmod >= n_emods) cmod = n_emods - 1;
							}
						break;
					case 2:
						n_unit = 0;
						n_emods = 1;
						cmod = 0;
						break;
					case 3:
						load_map();
						break;
					case 4:
						strcpy(buf, map_path);
						if (file_select("Save map", buf, "MAP")) {
							if (fl = fopen(buf, "wb")) {
								write_int(fl, &board_w);
								write_int(fl, &board_h);
								write_int(fl, &n_emods);
								for (j = 1; j < n_emods; ++j) {
									fputs(emods[j], fl);
									fputc('\n', fl);
									}
								for (j = 0; j < board_w; ++j)
									for (k = 0; k < board_h; ++k)
										write_int(fl, &(tile[j][k]));
								write_int(fl, &n_unit);
								for (j = 1; j < n_unit; ++j) {
									for (k = 0; k < n_emods; ++k)
										if (unit[j].mod == get_mod(emods[k]))
											write_int(fl, &k);
									write_int(fl, &unit[j].x);
									write_int(fl, &unit[j].y);
									write_int(fl, &unit[j].owner);
									}
								fclose(fl);
								strcpy(map_path, buf);
								}
							else
								msgbox("Error writing file");
							}
						text_mode(-1);
						show_mouse(mbuff);
						break;
					case 5:
						goto Main_Menu;
					}
				}
			}
		c_button = -1;
		}
	if (mouse_b & 2) {
		if (!mode) {
			if (cmod) {
				tile[(mouse_x - vpx) / TILE_W + win_x][(mouse_y - vpy) / TILE_H + win_y] = esamp[cmod];
				}
			}
		if (!mx2) {
			mx2 = mouse_x;
			my2 = mouse_y;
			}
		}
	else if (mx2 && n_selected && mouse_x >= vpx) {
		f = 1;
		for (j = 1; j < n_unit; ++j) {
			if (j != selected[0] && unit[j].hp && unit[j].x != -1 && mx2 >= vpx + (unit[j].x - win_x) * TILE_W && mx2 <= vpx + (unit[j].x + unit[j].w - win_x) * TILE_W && my2 >= vpy + (unit[j].y - win_y) * TILE_H && my2 <= vpy + (unit[j].y + unit[j].h - win_y) * TILE_H) {
				do_event2_selected(EVENT_RCLICK, j);
				f = 0;
				break;
				}
			}
		if (f) {
			for (j = 0; j < n_selected; ++j) {
				unit[selected[j]].tn = -1;
				unit[selected[j]].tr = 0;
				unit[selected[j]].tx = (mx2 - vpx) / TILE_W + win_x;
				unit[selected[j]].ty = (my2 - vpy) / TILE_H + win_y;
				}
			}
		mx2 = 0;
		}
	for (j = 0; j < n_unit; ++j) {
		if (unit[j].asp < unit[j].aspeed + unit[j].aspeed_bonus)
			++unit[j].asp;
		if (unit[j].taske) {
			if ((unit[j].mana += unit[j].bspeed + unit[j].bspeed_bonus) >= unit[j].smana) {
				unit[j].mana = 0;
				unit[j].smana = 0;
				do_event(j, unit[j].taske);
				unit[j].taske = 0;
				if (selected[0] == j)
					do_event_selected(EVENT_SELECT);
				}
			}
		}
	for (ctimer = 0; ctimer < n_timers; ++ctimer) {
		if (++timers[ctimer].tick >= timers[ctimer].speed) {
			if (!timers[ctimer].loop) {
				_remove_timer(ctimer);
				--ctimer;
				continue;
				}
			timers[ctimer].tick = 0;
			j = n_timers;
			run_xc_mono(timers[ctimer].mod, MEMSZ, 4, (int64)timers[ctimer].ty, (int64)timers[ctimer].tx, (int64)timers[ctimer].u, (int64)timers[ctimer].e);
			if (j != n_timers) {
				--ctimer;
				continue;
				}
			if (errno) {
				sprintf(buf, "Module caused exception %d", errno);
				msgbox(buf);
				}
			if (timers[ctimer].loop >= 0)
				--timers[ctimer].loop;
			}
		}
	think_all();
	render();
	}

goto Main_Menu;

}
