#define int16 short
#define int32 int
#ifdef LCC
#define int64 _int64
#else
#define int64 long long
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <errno.h>
#include <stdarg.h>
//#include <windows.h>
//#include <winsock.h>

#define SIZE_8 0
#define SIZE_16 1
#define SIZE_32 2
#define SIZE_64 3

#ifdef BUILD_LIB
char tsz[4] = {1, 2, 4, 8};
unsigned int64 msb[4] = {0x80ULL, 0x8000ULL, 0x80000000ULL, 0x8000000000000000ULL};
unsigned int64 imax[4] = {0xFFULL, 0xFFFFULL, 0xFFFFFFFFULL, 0xFFFFFFFFFFFFFFFFULL};
unsigned int64 makeneg[4] = {0xFFFFFFFFFFFFFF00ULL, 0xFFFFFFFFFFFF0000ULL, 0xFFFFFFFF00000000ULL, 0x0ULL};
#endif

#define TYPE_CONST 0
#define TYPE_REG 4
#define TYPE_LPTR 8
#define TYPE_HPTR 12
#define TYPE_PTR 8

#define OP_NOP 0
#define OP_LD_RR 1
#define OP_LD_RC 5
#define OP_LD_RMC 9
#define OP_LD_RMR 13
#define OP_LD_RHC 17
#define OP_LD_RHR 21
#define OP_LD_MCR 25
#define OP_LD_MRR 29
#define OP_LD_HCR 33
#define OP_LD_HRR 37
#define OP_ADD 41
#define OP_FADD 45
#define OP_SUB 49
#define OP_FSUB 53
#define OP_MULT 57
#define OP_MULTS 61
#define OP_FMULT 65
#define OP_FMULTS 69
#define OP_DIV 73
#define OP_DIVS 77
#define OP_FDIV 81
#define OP_FDIVS 85
#define OP_MOD 89
#define OP_MODS 93
#define OP_SL 97
#define OP_SLN 101
#define OP_SR 105
#define OP_SRN 109
#define OP_NEG 113
#define OP_FNEG 117
#define OP_OR 121
#define OP_AND 125
#define OP_NOT 129
#define OP_XOR 133
#define OP_BOR 137
#define OP_BAND 141
#define OP_BNOT 145
#define OP_CP 149
#define OP_JP 153
#define OP_JP_Z 154
#define OP_JP_NZ 155
#define OP_JP_C 156
#define OP_JP_NC 157
#define OP_CALL_C 158
#define OP_CALL_R 159
#define OP_RET 160
#define OP_RETV 161
#define OP_HCALL_C 165
#define OP_HCALL_R 166
#define OP_INC 167
#define OP_DEC 171
#define OP_PUSH 175
#define OP_POP 179
#define OP_JP_R 183
#define OP_JP_R_Z 184
#define OP_JP_R_NZ 185
#define OP_JP_R_C 186
#define OP_JP_R_NC 187
#define OP_ARG_C 188
#define OP_ARG_R 192
#define OP_HCPY 196
#define OP_HSCPY 197
#define OP_MCPY 198
#define OP_CPY 199
#define OP_SCPY 200
#define OP_DCPY 201

#define N_REG 16
#define S_REG 4
#define N_STACK 255
#define N_CSTACK 255
#define N_HOSTSYM 65535
#define N_ARG 255
#define MAX_DATA 255
#define MAX_DSZ 255

#define xc_export_var(X,Y,Z) _xc_export_var((void*)X, (unsigned char)Y, Z)
#define xc_func(X) int64 X(xinst *xi, int argc, int64 argv[])
#define inst_ptr(X) (&(xi->mem[X]))

#define XC_ERR_NONE 0
#define XC_ERR_FILE_OPEN 1
#define XC_ERR_MALLOC 2
#define XC_ERR_INST_LIMIT 3
#define XC_ERR_NO_INST 4
#define XC_ERR_SEGFAULT 5
#define XC_ERR_DIV_BY_ZERO 6
#define XC_ERR_STACK_OVERFLOW 7
#define XC_ERR_STACK_UNDERFLOW 8
#define XC_ERR_CSTACK_OVERFLOW 9
#define XC_ERR_HOSTSYM_OVERFLOW 10
#define XC_ERR_HOSTSYM_SEGFAULT 11
#define XC_ERR_HOSTSYM_TYPE 12
#define XC_ERR_NULL_PTR 13

#define XC_TYPE_VOID 0
#define XC_TYPE_CHAR 1
#define	XC_TYPE_INT 2
#define XC_TYPE_SHORT 4
#define XC_TYPE_LONG 5

#define MAX_INST 255

typedef int64 (*xcfunc)();

typedef struct datat {
	unsigned char dat[MAX_DSZ];
	int sz;
	} datat;

typedef struct xc {
	unsigned char *code, *code_end;
	datat data[MAX_DATA];
	int n_data;
	} xc;

typedef struct xinst {
	xc *parent;
	unsigned char *code, *code_end, *cp, *mem, reg[N_REG][S_REG], stack[N_STACK][S_REG];
	unsigned char *cstack[N_CSTACK], z, c, priority;
	int64 arg[N_ARG];
	int memsz, stackp, cstackp, argp;
	} xinst;

typedef struct hostsymt {
	unsigned char type;
	void *ptr;
	int sz;
	} hostsymt;

#ifdef BUILD_LIB
hostsymt hostsym[N_HOSTSYM];
int n_hostsym;
xcfunc hostfunc[N_HOSTSYM];
int n_hostfunc;

int n_inst = 0, c_inst = 0;
xinst *insts[MAX_INST];
#else
extern hostsymt hostsym[N_HOSTSYM];
extern int n_hostsym;
extern xcfunc hostfunc[N_HOSTSYM];
extern int n_hostfunc;

extern int n_inst, c_inst;
extern xinst *insts[MAX_INST];
#endif

#ifndef BUILD_LIB
extern int _xc_export_var(void*, unsigned char, int);
extern int xc_export_func(xcfunc);
extern xc *load_xc(char*);
extern int unload_xc(xc*);
extern int run_xc_mono(xc*, unsigned int, int, ...);
extern xinst *run_xc(xc*, unsigned int, unsigned char, int, ...);
extern int unload_xinst(xinst*);
extern int do_xcode(int);
#endif
